#include maps\_utility;
#include maps\_anim;
#using_animtree("generic_human");



main()
{

////LOAD MAIN FILES////

maps\_panzer2::main("xmodel/vehicle_panzer_ii_winter");
maps\_tankai::main();
maps\Leningrad_fx::main();
maps\Leningrad_anim::main();
maps\_mortar::generic_style_init();
maps\_load::main();


////ENVIRONMENT////

setEnvironment ("cold");
setExpFog(0.00063, .58, .57, .57, 0);

	
////AMBIENT SOUND////

ambientPlay("ambient_Leningrad");


////PRECACHING////

precacheShellshock("default");
precacheshader("black");
precachestring(&"LENINGRAD_leningrad_INTRO_1");
precachestring(&"LENINGRAD_leningrad_INTRO_2");
precachestring(&"LENINGRAD_leningrad_INTRO_3");
level.smokegrenade = loadfx("fx/smoke/smoke_grenade_duhoc_40sec.efx");


////PLAYER SETUP////
     
level.player takeallweapons(); 
level.player giveWeapon("svt40"); 
level.player giveWeapon("tt30"); 
level.player giveWeapon("smoke_grenade_russian");
level.player giveWeapon("rgd-33russianfrag"); 
level.player switchToWeapon("svt40");
level.player setViewmodel("xmodel/viewmodel_hands_russian" );	


////MORTARS SETUP////

level.explosion_startNotify["mortar"] 	= "start_mortars";
level.explosion_stopNotify["mortar"] 	= "stop_mortars";
level.explosion_startNotify["mortar2"] 	= "start_mortars2";
level.explosion_stopNotify["mortar2"] 	= "stop_mortars2";
level._effect["mortar"] 		= loadfx("fx/explosions/large_snow_explode1.efx");
level._effect["mortar2"] 		= loadfx("fx/explosions/large_snow_explode1.efx");
level._effectType["mortar"]		= "mortar";
level._effectType["mortar2"]		= "mortar";
level.mortar 				= level._effect["mortar"];


////INTRO SCREEN////

maps\_introscreen::introscreen_delay(&"LENINGRAD_leningrad_INTRO_1",
&"LENINGRAD_leningrad_INTRO_2",
&"LENINGRAD_leningrad_INTRO_3"); 


////THREADS////

thread triggers();
thread characters();



}



triggers()
{

level.wave = getent("wave_trig", "targetname");
level.wave triggeroff();
level.tf1 = getent("tf1", "targetname");
level.tf1 triggeroff();
level.tf2 = getent("tf2", "targetname");
level.tf2 triggeroff();
level.tf4 = getent("tf4", "targetname");
level.tf5 = getent("tf5", "targetname");
level.tf5 triggeroff();
level.tf6 = getent("tf6", "targetname");
level.tf6 triggeroff();
level.tf7 = getent("tf7", "targetname");
level.tf7 triggeroff();
level.tf8 = getent("tf8", "targetname");
level.tf8 triggeroff();
level.tf9 = getent("tf9", "targetname");
level.tf9 triggeroff();
level.tf10 = getent("tf10", "targetname");
level.tf10 triggeroff();
deathtrig = getent("deathtrig", "targetname");
deathtrig triggeroff();

thread mortars();
thread leader();

}



characters()
{

a1 = getent ("a1", "targetname");
a1 thread maps\_utility::magic_bullet_shield();
a2 = getent ("a2", "targetname");
a2 thread maps\_utility::magic_bullet_shield();
a3 = getent ("a3", "targetname");
a3 thread maps\_utility::magic_bullet_shield();
a4 = getent ("a4", "targetname");
a4 thread maps\_utility::magic_bullet_shield();
a5 = getent ("a5", "targetname");
a5 thread maps\_utility::magic_bullet_shield();
a6 = getent ("a6", "targetname");
a6 thread maps\_utility::magic_bullet_shield();
a7 = getent ("a7", "targetname");
a7 thread maps\_utility::magic_bullet_shield();
a8 = getent ("a8", "targetname");
a8 thread maps\_utility::magic_bullet_shield();
a9 = getent ("a9", "targetname");
a9 thread maps\_utility::magic_bullet_shield();

}



mortars()
{

playerclip = getent("blockstart", "targetname");
playerclip solid();
level.player playsound("downtownassault_volsky_takecover");
thread maps\_mortar::generic_style("mortar", 2, undefined, undefined, 10, 2000, undefined);
level notify ("start_mortars");
wait(25);
level notify ("stop_mortars");
wait(1);
level.wave triggerOn();

}



leader()
{

level.leader = getent("leader", "script_noteworthy");
level.leader thread maps\_utility::magic_bullet_shield();
trig = getent("wave_trig", "targetname");
trig waittill("trigger");

level.leader.animname = "leader";
wave_node = getnode ("wave_node", "targetname");
wave_node anim_reach_solo (level.leader, "letsgocomrades");
wave_node  thread anim_single_solo(level.leader, "letsgocomrades");

level.leader setgoalnode(getnode("wall_node", "targetname"));
level.tf1 triggerOn();
playerclip = getent("blockstart", "targetname");
playerclip delete();
wait(7);

level.hunt = getent("hunt", "targetname");
level.hunt playsound("hunt");
wait(6);
level.leader playsound("newvillers_bs4_brokenwall");
thread obj1();

level.leader waittill("goal");
wait(8);
maps\_utility::levelStartSave();
wall_node = getnode ("wall_node", "targetname");
wall_node anim_reach_solo (level.leader, "getready");
wall_node  thread anim_single_solo(level.leader, "getready");
wait(12);

wall_node anim_reach_solo (level.leader, "attack");
wall_node  thread anim_single_solo(level.leader, "attack");
level.charge = getent("charge", "targetname");
wait(1);
level.charge playsound("charge");
level.tf2 triggerOn();
smokegrenade1 = getent("smokegrenade1", "targetname");
smokegrenade2 = getent("smokegrenade2", "targetname");
playfx(level.smokegrenade, smokegrenade1.origin);
playfx(level.smokegrenade, smokegrenade2.origin);
thread frontline_trench1();
thread frontline_trench2();

level.leader setgoalnode(getnode("field", "targetname"));
thread maps\_mortar::generic_style("mortar2", 3, undefined, undefined, 10, 2000, undefined);
level notify ("start_mortars2");

}


mortar_leader()
{

barn2_node = getnode ("barn2", "targetname");
level.leader setgoalnode(getnode("barn2", "targetname"));
wait(8);
level.tf7 triggerOn();
thread obj4();
barn2_node anim_reach_solo (level.leader, "mortars");
barn2_node  thread anim_single_solo(level.leader, "mortars");
thread mortar_guys();
thread tunnel_guys();
level.leader setgoalnode(getnode("mortar_node", "targetname"));
wait(25);
level.player playsound("moscow_rs2_vasilimortar");

}


flak_leader()
{

flak_speech = getnode ("flak_speech", "targetname");
level.leader setgoalnode(getnode("flak_speech", "targetname"));
level.leader waittill("goal");
wait(7);
flak_speech anim_reach_solo (level.leader, "flak");
flak_speech  thread anim_single_solo(level.leader, "flak");
wait(5);
thread obj6();
level.leader playsound("downtownsniper_volsky_notimetowaste");
wait(2.1);
thread blockade1();
thread blockade2();
flak_speech anim_reach_solo (level.leader, "flakgo");
flak_speech  thread anim_single_solo(level.leader, "flakgo");
wait(1);
level.tf10 triggerOn();
level.leader setgoalnode(getnode("blockade_node", "targetname"));
song = getent("song", "targetname");
song playsound("song");
wait(8);
level.leader playsound("demolition_rs4_moveitrun");
level.leader waittill("goal");
wait(5);
level.leader playsound("downtownassault_volsky_movein");
trig = getent("tf11", "targetname");
trig waittill("trigger");
level.leader setgoalnode(getnode("trench_node", "targetname"));

}


fake_end()
{

wait(3);
level.player playsound("cityhall_vsk_takenit");
wait(7);
tanks_rumble = getent("tanks_rumble", "targetname");
tanks_rumble playsound("tanks_rumble");
earthquake(.12, 30, level.player.origin, 850);
wait(5);
level.player playsound("cityhall_rs2_counterattack");
wait(4);
thread obj7();
thread tank1();
thread tank2();
thread counter_attack();
level.player playsound("demolition_rs4_getdownnn");
wait(5);
counter_song = getent("counter_song", "targetname");
counter_song playsound("counter_song");
level.player playsound("demolition_rs4_holdline");
wait(6);
level.player playsound("downtownsniper_volsky_findantitank");
wait(20);
level.player playsound("tankhunt_volsky_thendestroytank");

}



tank1()
{	
aVehicle = maps\_vehicle::scripted_spawn(1);
panzer_1 = aVehicle[0];
panzer_1.pos_id = 0;

level thread maps\_vehicle::gopath(panzer_1);
wait(12);
thread tank1_shoot();
}


tank2()
{	
aVehicle = maps\_vehicle::scripted_spawn(2);
panzer_2 = aVehicle[0];
panzer_2.pos_id = 0;

level thread maps\_vehicle::gopath(panzer_2);
wait(10);
thread tank2_shoot();
}


tank1_shoot()
{

tank1 = getent ("tank1","script_noteworthy");
tank1 endon ("death");

tank1 setTurretTargetVec(level.player.origin);
wait(.5);
tank1 waittill ("turret_on_target");
tank1 notify ("turret_fire");
tank1 clearTurretTarget();
wait(6);
thread tank1_shoot();

}


tank2_shoot()
{

tank2 = getent ("tank2","script_noteworthy");
tank2 endon ("death");

tank2 setTurretTargetVec(level.player.origin);
wait(1);
tank2 waittill ("turret_on_target");
tank2 notify ("turret_fire");
tank2 clearTurretTarget();
wait(3);
thread tank2_shoot();

}

//////// SPAWNING ////////


frontline_trench1()
{

spawners = getentarray("trench1", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


frontline_trench2()
{

wait(5);
spawners = getentarray("trench2", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


barn1_out()
{

spawners = getentarray("barn1_out", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


barn1_in()
{

wait(10);
spawners = getentarray("barn1_in", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


roadblock()
{

spawners = getentarray("roadblock", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


barn2()
{

wait(10);
spawners = getentarray("barn2_in", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


mortar_guys()
{

spawners = getentarray("mortar_guy", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


tunnel_guys()
{

spawners = getentarray("tunnel", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


flaks()
{

spawners = getentarray("flaks", "targetname");
for (i=0; i < spawners.size; i++ )
{
// if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


flak_rushers()
{

spawners = getentarray("flak_rushers", "targetname");
level thread maps\_spawner::spawnerflood_spawn (spawners);
for (i=0; i < spawners.size; i++ )
{
if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


blockade1()
{

spawners = getentarray("blockade1", "targetname");
for (i=0; i < spawners.size; i++ )
{
//if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}



blockade2()
{

spawners = getentarray("blockade2", "targetname");
for (i=0; i < spawners.size; i++ )
{
//if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


counter_attack()
{

spawners = getentarray("counter", "script_noteworthy");
level thread maps\_spawner::spawnerflood_spawn (spawners);
for (i=0; i < spawners.size; i++ )
{
if(isalive(spawners[i]))
{
spawners[i] stalingradspawn();
}
}
}


/////// OBJECTIVES ///////


obj1()
{

a1 = getent ("a1", "targetname");
a1 notify("stop magic bullet shield");

objective_add(1, "active", &"LENINGRAD_OBJ_TRENCHES", (2270, 9628, 8));
objective_current (1);
trig = getent("tf2", "targetname");
trig waittill("trigger");
wait(10);
done = getentarray("frontline_trench", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}

wait(3);
objective_state(1, "done");
maps\_utility::levelStartSave();
thread obj2();
wait(2);
thread barn1_out();
thread barn1_in();
level.tf5 triggerOn();
level.tf4 triggeroff();
wait(30);
level.tf5 triggeroff();


}


obj2()
{

a2 = getent ("a2", "targetname");
a2 notify("stop magic bullet shield");

objective_add(2, "active", &"LENINGRAD_OBJ_BARN1", (-696, 10440, 24));
objective_current (2);
wait(20);
done = getentarray("barn1", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}
wait(3);
objective_state(2, "done");
maps\_utility::levelStartSave();
thread obj3();
wait(2);
thread roadblock();
thread barn2();
level.tf6 triggerOn();
wait(10);
level.tf6 triggeroff();
level.leader setgoalnode(getnode("barn1", "targetname"));

}


obj3()
{

a3 = getent ("a3", "targetname");
a3 notify("stop magic bullet shield");

objective_add(3, "active", &"LENINGRAD_OBJ_BARN2", (1630, 13334, 24));
objective_current (3);
smokegrenade3 = getent("smokegrenade3", "targetname");
playfx(level.smokegrenade, smokegrenade3.origin);
wait(10);
level.player playsound("tankhunt_volsky_flankaroundmg42");
wait(20);
done = getentarray("barn2", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}
wait(3);
objective_state(3, "done");
maps\_utility::levelStartSave();
thread mortar_leader();
wait(20);
level notify ("stop_mortars2");

}


obj4()
{

objective_add(4, "active", &"LENINGRAD_OBJ_MORTARS", (-1119, 16319, 16));
objective_current (4);
a4 = getent ("a4", "targetname");
a4 notify("stop magic bullet shield");
level.radio = getent("radio", "targetname");
level.radio playloopsound("radio");
wait(20);
done = getentarray("mortar", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}
wait(1);
level.player playsound("downtownsniper_volsky_thatsit");
wait(2);
objective_state(4, "done");
maps\_utility::levelStartSave();
thread obj5();

}


obj5()
{

objective_add(5, "active", &"LENINGRAD_OBJ_FLAKS", (2411, 18265, 24));
objective_current (5);
level.leader setgoalnode(getnode("flak_node", "targetname"));
level.tf8 triggerOn();
thread flaks();
wait(3);
level.player playsound("commissar_charge_keepforward");
wait(20);
done = getentarray("flaks", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}
wait(2);
thread flak_rushers();
wait(1);
level.player playsound("downtownsniper_volsky_goodshooting");
wait(4);
level.player playsound("demolition_rs4_heretheycome");
f = getent("flak_song", "targetname");
f playsound("flak_song");
wait(40);
killed = getentarray("flak_rushers", "script_noteworthy");
for (i=0; i < killed.size; i++ )

{
	if(isAlive(killed[i]))

	killed[i] waittill("death");

	continue;

		}

wait(3);
objective_state(5, "done");
maps\_utility::levelStartSave();
level.tf9 triggerOn();
thread flak_leader();


}


obj6()
{

objective_add(6, "active", &"LENINGRAD_OBJ_BLOCKADE", (512, 24480, 24));
objective_current (6);
wait(30);
done = getentarray("blockade", "script_noteworthy");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}

wait(3);
objective_state(6, "done");
maps\_utility::levelStartSave();
thread fake_end();

}


obj7()
{

objective_add(7, "active", &"LENINGRAD_OBJ_COUNTER_ATTACK", (512, 24480, 24));
objective_current (7);
wait(20);
done = getentarray("tanks", "targetname");
for (i=0; i < done.size; i++ )

{
	if(isAlive(done[i]))

	done[i] waittill("death");

	continue;

		}


wait(5);
dead = getentarray("counter", "script_noteworthy");
for (i=0; i < dead.size; i++ )

{
	if(isAlive(dead[i]))

	dead[i] waittill("death");

	continue;

		}
deathtrig = getent("deathtrig", "targetname");
deathtrig triggerOn();
wait(3);
objective_state(7, "done");
wait(5);
level.player playsound("cityhall_vsk_itsover");
wait(2);
level.player playsound("cityhall_vsk_thankgod");
wait(3);
level.player playsound("downtownsniper_volsky_numbersdidntcomeup");
wait(7);
level.player playsound("hurrah");
level.leader playsound("hurrah2");
wait(1);
level.player playsound("cheers");
wait(3);
b = getent("anthem", "targetname");
b playsound("anthem");
wait(12);
setCvar("ui_victoryquote", "@VICTORYQUOTE_WE_SHALL_DEFEND_OUR_ISLAND");
setsavedcvar("ui_nextmission","3");
missionSuccess("training", false);
}











